
// SETTINGS or defaults
var _server = 'http://'+window.location.hostname+':'+window.location.port;
var server = localStorage.server ? localStorage.server : _server; 
// var server = "http://localhost:8080";
var _defaultBrowse = 'file://~';
var defaultBrowse = localStorage.defaultBrowse ? 'file://'+encodeURIComponent(localStorage.defaultBrowse) : _defaultBrowse;
var maxVolume = localStorage.maxVolume ? localStorage.maxVolume : true;
var useChapters = localStorage.useChapters ? localStorage.useChapters : true;
var _updateInterval = 5;
var updateInterval = localStorage.updateInterval ? localStorage.updateInterval : _updateInterval;

function VLC()
{/*
	    <header class="bar bar-nav">
    
      <h1 class="title"><img src=img/vlc16x16.png alt=vlclogo class="icon" /> VLC - Remote Controller</h1>
    </header>*/
	that = this;
	
	this.titleBar = $('<header>', {'class':'bar bar-nav'})
		.append('<h1 class="title"><img src=img/vlc16x16.png alt="VideoLan Logo" class="icon" /> VLC - Remote Controller</h1>')
		.append('<a class="icon icon-gear pull-right" href=#settings></a>')
		.appendTo('body');
	this.buildSettings();
	this.infoModal = this._modal('info', '<span class="icon icon-info"></span> Informations');
	this.streamModal = this._modal('streams', '<span class="icon icon-more"></span> Streams').find('.content').append('<ul class=table-view></ul>');
	this.plModal = this._modal('playlist', '<span class="icon icon-list"></span> Playlists').find('.content').append('<ul class="table-view"></ul>').find('ul.table-view');
	
	this.content = $('<div class=content>').appendTo('body');
	this.albumArt = $('<img id=albumArt style="margin-top:44px; margin-bottom:50px; margin-left: auto; margin-right:auto; max-height:100%; max-width:100%" alt=albumart src="img/vlc-48.png" />').appendTo(this.content);
	
	this.navBar = $('<nav>', {'class':'bar bar-tab'}).appendTo('body'); 
	this.nav = {};
	this.staticButtons();

	
	this.browseModal = this._modal('browse', '<span class="icon icon-search"></span> Browse').find('.content');
	this.Browse();
	
	//every 10 seconds;
	setInterval(function(){that.updateStatus()}, updateInterval*1000);
	return this;
}

VLC.prototype = 
{
	updateStatus: function()
	{
		that = this;
		$.ajax({
			url: server + '/requests/status.json',
			success:function(data, status, error)
			{
				that.status = data;
// 				console.log(data);
				that.updateButtons();
				that.updateArt();
			},
			error: function (jqXHR, status, error)
			{
				setTimeout(updateStatus, 500);
				console.log('Error in ajax request, retrying...');
			},
			dataType: 'json'
		});
		
	},
	
	sendCommand: function(command)
	{
		that = this;
		if(typeof command != 'object')
			command = {'command':command};
		$.ajax({
			url: server+'/requests/status.json',
			data: command,
			success:function(data)
			{
				that.status = data;
			},
			dataType:'json'
		});
// 		setTimeout(this.updateButtons, 500);
		return this;
	},
	
	Pause: function()
	{
		this.sendCommand('pl_pause').updateButtons();
		return this;
	},
	
	Play: function(id)
	{
		if(id == undefined)
			this.sendCommand('pl_play').updateButtons();
		else
			this.sendCommand({'command':'pl_play', 'id':id}).updateButtons();
		//TODO : add ID playlist to play;
		return this;
	},
	
	Stop: function()
	{
		this.sendCommand('pl_stop').updateButtons();
		return this;
	},
	
	Next:function()
	{
		if(this.status.information.chapters.length > 1 && this.status.information.chapter < this.status.information.chapters.length && useChapters)
			this.sendCommand({'command':'chapter', 'val':this.status.information.chapter+1});
		else
			this.sendCommand('pl_next');
		return this;
	},
	
	Prev: function()
	{
		if(this.status.information.chapters.length > 1 && this.status.information.chapter > 0 && useChapters)
			this.sendCommand({'command':'chapter', 'val':this.status.information.chapter-1});
		else
			this.sendCommand('pl_previous');
		return this;
	},
	
	Fullscreen: function()
	{
		this.sendCommand('fullscreen');
		return this;
	},
	
	_modal:function(id, title)
	{
		return $('<div>', {'id':id, 'class':'modal'})
			.append($('<header>', {'class':'bar bar-nav'})
				.append($('<a>', {'class':'icon icon-close pull-right', 'href':'javascript:void(0);'}).click(function(){$(this).parent().parent().removeClass('active')}))
				.append($('<h1>', {'class':'title', html:title})))
			.append($('<div>', {'class':'content'}))
			.appendTo('body');
	},
	
	Browse: function(dir)
	{
		that = this;
		dir = dir == undefined ? defaultBrowse : dir;
		$.ajax({
			url: 'requests/browse.json',
			data: {'uri' :dir },
			success: function (data) {
				that.browseModal.empty().append($('<ul class="table-view">')
// 					.append($('<li class="table-view-cell">', {html:'<span class="media-object pull-left icon icon-left-nav"></span> ..'}))
					);
				$(data.element).each(function(){
					ext = this.name.substr(this.name.lastIndexOf('.') + 1).toLowerCase();
					if($.inArray(ext, video_types) != -1 || $.inArray(ext, audio_types) != -1 || $.inArray(ext, playlist_types) != -1 || this.type=='dir')
						that.browseModal.find('ul.table-view')
						.append($('<li class="table-view-cell">')
							.append(
								(this.type == 'dir' ?
									(this.name == '..' ? 
										$('<a data-opendir="'+this.uri+'" class="navigate-left"><span class="pull-right">Back</span></a>').click(function(){that.Browse($(this).attr('data-opendir'))})
									:	$('<a data-opendir="'+this.uri+'" class="navigate-right">'+this.name+'</a>').click(function(){that.Browse($(this).attr('data-opendir'))}))
								:	$('<a data-openfile="'+this.uri+'"><span class="media-object pull-left icon icon-play"></span> '+this.name+'</a>').click(function(){that.sendCommand({'command':'in_play', 'input':$(this).attr('data-openfile')});that.browseModal.parent().removeClass('active')})
								)
							 ));
					else if($.inArray(ext, subtitle_types) != -1)
						that.browseModal.find('ul.table-view')
						.append($('<li class="table-view-cell">')
							.append(
								$('<a data-openfile="'+this.uri+'"><span class="media-object pull-left icon-bars icon"></span> '+this.name+'</a>').click(function(){that.sendCommand({'command':'addsubtitle', 'val':$(this).attr('data-openfile')});that.browseModal.parent().removeClass('active')})
							 ));
					
				});
				return this;
			},
			error: function(){	setTimeout(function(){that.Browse(dir)}, 1000) },
			dataType:'json'
		});
		return this;
	},
	
	buildSettings: function()
	{
		this._modal('settings', '<span class="icon icon-gear"></span> Settings').find('.content')
			.append($('<ul>', {'class':'table-view'})
				.append($('<li>', {'class':'table-view-divider'})
					.append('VLC Location'))
				.append($('<li>', {'class':'input-row'})
					.append('<label>Server</label>')
					.append($('<input>', {'type':'text', 'value':localStorage.server, 'placeholder':server})
						.change(function(){
							if($(this).val() != '')
								server = localStorage.server = $(this).val();
							else
							{
								delete localStorage.server;
								server = _server;
							}})
					)
				 )
// 				.append($('<li>', {'class':'table-view-cell'})
// 					.append('<p><em>Leave blank if you\'re not sure. By default, it will reach the same server.</em></p>')
// 				)
				.append($('<li>', {'class':'table-view-divider'})
					.append('Configuration'))
				.append($('<li>', {'class':'input-row'})
					.append('<label>Update Interval</label>')
					.append($('<input>', {'type':'text','value':localStorage.updateInterval, 'placeholder':_updateInterval})
						.change(function(){
							if($(this).val() != '')
								localStorage.updateInterval = updateInterval = $(this).val();
							else
							{
								delete localStorage.updateInterval;
								updateInterval = _updateInterval;
								
							}})
					)
				)
				.append($('<li>', {'class':'input-row'})
					.append('<label>Browser</label>')
					.append($('<input>', {'type':'text','value':localStorage.defaultBrowse, 'placeholder':'~'})
						.change(function(){
							if($(this).val() != '')
								localStorage.defaultBrowse = defaultBrowse = $(this).val();
							else
							{
								delete localStorage.defaultBrowse;
								defaultBrowse = _defaultBrowse;
								
							}})
					)
				)
				.append($('<li>', {'class':'table-view-cell'})
					.append('Max Vol. 100%')
					.append($('<div>', {'class':maxVolume ? 'toggle active' : 'toggle'})
						.append($('<div>', {'class':'toggle-handle'}))
						.on('toggle', function(){maxVolume = $(this).hasClass('active') ? true : false; localStorage.maxVolume = maxVolume;})
					)
					.append('<p>Prevent volume from going higher than 100%</p>')
				)
				.append($('<li>', {'class':'table-view-cell'})
					.append('Chapters')
					.append($('<div>', {'class': useChapters ? 'toggle active' : 'toggle'})
						.append($('<div>', {'class':'toggle-handle'}))
						.on('toggle', function(){useChapters = $(this).hasClass('active') ? true : false; localStorage.useChapters = useChapters;})
					)
					.append('<p>This will first seek for the next or previous chapter within the playing file, instead of switching to the next file of the internal VLC playlist.</p>')
				)
// 				.append($('<li>', {'class':'table-view-cell'})
// 					.append($('<button>', {'class':'btn', text:'Test'})
// 						.click(function(){alert(maxVolume + ' lS:'+localStorage.maxVolume+"\n"+useChapters+' lS:'+localStorage.useChapters)})
// 					)
// 				)
// 				.append($('<li>', {'class':'table-view-cell'})
// 					.append('Setting 2')
// 					.append($('<div>', {'class':'toggle'})
// 						.append($('<div>', {'class':'toggle-handle'}))
// 					 )
// 				)
			 )	
			;
		return this;
	},
	
	Volume: function(a)
	{
// 		if(this.status.volume == 0 && !a)	return this;
// 		if(this.status.volume == 256 && a && maxVolume==true)	return this;
		if((this.status.volume >= 256 || this.status.volume > 230) && a && maxVolume==true)	return this.sendCommand({'command':'volume', 'val':256}); // max : 256/512 = 100%
		if(this.status.volume <= 26 && !a)	return this.sendCommand({'command':'volume', 'val':0}); // min : 0;
		return this.sendCommand({'command':'volume', 'val': a ? this.status.volume + 26 : this.status.volume -26 });
	},
	
	staticButtons : function()
	{
		that = this;
		this.nav.search = $('<a class="tab-item" href=#browse>')
			.append('<span class="icon icon-search"></span>')
			.append('<span class="tab-label">Open</span>')
			.appendTo(this.navBar)
// 			.click(function(){ that.Browse() });
		this.nav.playpause = $('<a class="tab-item" href="javascript:void(0);">').appendTo(this.navBar);
		this.nav.stop = $('<a class="tab-item" href=javascript:void(0);>')
			.append('<span class="icon icon-stop"></span>')
			.append('<span class="tab-label">Stop</span>')
			.appendTo(this.navBar)
			.click(function(){ that.Stop() });
		this.nav.fullscreen = $('<a class="tab-item" href="javascript:void(0);">')
			.append('<span class="icon icon-code"></span>')
			.append('<span class="tab-label">Fullscreen</span>')
			.appendTo(this.navBar)
			.click(function(){ that.Fullscreen(); $(this).toggleClass('active'); });
		this.nav.volume1 = $('<a class="tab-item" href=javascript:void(0);>')
			.append('<span class="icon icon-sound4"></span>')
			.append('<span class="tab-label">Volume -</span>')
			.appendTo(this.navBar)
			.click(function(){ that.Volume(0) });
		this.nav.volume2 = $('<a class="tab-item" href=javascript:void(0);>')
			.append('<span class="icon icon-sound"></span>')
			.append('<span class="tab-label">Volume +</span>')
			.appendTo(this.navBar)
			.click(function(){ that.Volume(1) });

		
		return this;
	},
	
	updateButtons: function()
	{
// 		  <a class="tab-item active" href="#">
//     <span class="icon icon-search"></span>
//     <span class="tab-label">Open</span>
//   </a>	
// 		console.log(this.status);
		that = this;
		
		if(this.status.fullscreen == true)
			if(!this.nav.fullscreen.hasClass('active'))
				this.nav.fullscreen.addClass('active');
			else;
		else
			this.nav.fullscreen.removeClass('active');
		if(this.status.state == 'playing')
			this.nav.playpause.empty().append('<span class="icon icon-pause"></span>').append('<span class="tab-label">Pause</span>')
				.unbind("click").click(function(){ that.Pause()});
		else	this.nav.playpause.empty().append('<span class="icon icon-play"></span>').append('<span class="tab-label">Play</span>')
				.unbind('click').click(function(){ that.Play()});
		volume=Math.floor(this.status.volume/2.56/25);
// 		console.log(volume);
		switch(volume)
		{
			default:
			case 0:
				this.nav.volume1.html('<span class="icon icon-sound4"></span><span class="tab-label">Volume -</span>');
				this.nav.volume2.html('<span class="icon icon-sound3"></span><span class="tab-label">Volume +</span>');
			break;
			case 1:
			case 2:
				this.nav.volume1.html('<span class="icon icon-sound3"></span><span class="tab-label">Volume -</span>');
				this.nav.volume2.html('<span class="icon icon-sound2"></span><span class="tab-label">Volume +</span>');
			break;			
			case 3:
			case 4:	case 5: case 6: case 7: case 8:
				this.nav.volume1.html('<span class="icon icon-sound2"></span><span class="tab-label">Volume -</span>');
				this.nav.volume2.html('<span class="icon icon-sound"></span><span class="tab-label">Volume +</span>');
			break;
		}
		return this;
	},
	
	buildPlaylist: function(data)
	{
		that = this;
		$.each(data.children, function(){
			that.plModal.append('<li class="table-view-divider">'+this.name+'</li>');
			$.each(this.children, function(){
				that.plModal.append(
					$('<li>', {'class':'table-view-cell'})
					.append(this.current ? '<span class="media-object pull-left icon icon-play"></span> '+this.name
						: 	$('<a data-id="'+this.id+'" class="navigate-right" href=javascript:;>'+this.name+'</a>')
								.click(function(){
									that.Play($(this).attr('data-id')).plModal.parent().parent().removeClass('active');
								})
					       )
					)
			})
		});
		return this;	
	},
	
	updateArt: function()
	{
		that = this;
		if(this.status.information )
		{
			if(this.actualImg != this.status.information.category.meta.filename)
				this.albumArt.fadeOut(500, function(){
					$(this).removeAttr('height').removeAttr('width').removeClass('hidden').attr('src', '/art?'+that.status.information.category.meta.filename)
						.fadeIn(500).error(function(){$(this).attr('src', 'img/vlc-48.png');});
						
					that.infoModal
						.find('header h1').html('<span class="icon icon-info"></span> '+that.status.information.category.meta.title || "Informations").end()
						.find('.content').empty()
						.append($('<ul class=table-view>')/*
							.append($('<li class=table-view-cell>')
								.append(that.status.information.category.meta.title)
							 )*/
							.append('<li class="table-view-divider">Meta</li>')
							.append(that.status.information.category.meta.CONTENT_TYPE && that.status.information.category.meta.genre ? $('<li class=table-view-cell>')
								.append(that.status.information.category.meta.CONTENT_TYPE)
								.append('<p>'+that.status.information.category.meta.genre+'</p>') : ''
							)
							.append(that.status.information.category.meta.CONTENT_TYPE && !that.status.information.category.meta.genre ? $('<li class=table-view-cell>')
								.append('Type')
								.append('<p>'+that.status.information.category.meta.CONTENT_TYPE+'</p>') : ''
							)
							.append(that.status.information.category.meta.genre && !that.status.information.category.meta.CONTENT_TYPE ? $('<li class=table-view-cell>')
								.append('Genre')
								.append('<p>'+that.status.information.category.meta.genre+'</p>') : ''
							)
							.append(that.status.information.category.meta.description != undefined ? $('<li class=table-view-cell>')
								.append('Summary')
								.append('<p>'+that.status.information.category.meta.description+'</p>') : ''
							)
							.append(that.status.information.category.meta.date != undefined ? $('<li class=table-view-cell>')
								.append('Release Date')
								.append('<p>'+that.status.information.category.meta.date+'</p>') : ''
							)
							.append(that.status.information.category.meta.PRODUCTION_STUDIOS != undefined ? $('<li class=table-view-cell>')
								.append('Production Studios')
								.append('<p>'+that.status.information.category.meta.PRODUCTION_STUDIOS+'</p>') : ''
							)
							.append(that.status.information.category.meta.RECORDING_LOCATION != undefined ? $('<li class=table-view-cell>')
								.append('Recording Location')
								.append('<p>'+that.status.information.category.meta.RECORDING_LOCATION+'</p>') : ''
							)
						 );
// 					console.log(that.status.information);
					
					i = 0;
					that.streamModal.find('ul.table-view').empty();
					while(c=that.status.information.category['Stream '+i])
					{
// 						console.log(i);
// 						console.log(c);
						if(c.Type == 'Audio')
							that.streamModal.find('ul.table-view')
								.append($('<li class="table-view-cell">')
									.append($('<span class="media-object pull-left icon icon-sound4">'))
									.append('Audio ' + (c.Language || ''))
									.append(c.Channels ? '<p>'+c.Channels+'</p>' : '')
									.append(c.Description ? '<p>'+c.Description+'</p>' : '')
									.append($('<button type="button" data-val="'+i+'" class="btn btn-outlined btn-primary">').append('Select').click(function(){ that.sendCommand({'command':'audio_track','val':$(this).attr('data-val')});that.streamModal.parent().removeClass('active')}))
								 );
						else if(c.Type == 'Subtitle')
							that.streamModal.find('ul.table-view')
								.append($('<li class="table-view-cell">')
									.append($('<span class="media-object pull-left icon icon-bars">'))
									.append('Subtitle ' + (c.Language || ''))
									.append(c.Description ? '<p>'+c.Description+'</p>' : '')
									.append($('<button type="button" data-val="'+i+'" class="btn btn-primary btn-outlined">').append('Select').click(function(){ that.sendCommand({'command':'subtitle_track','val':$(this).attr('data-val')});that.streamModal.parent().removeClass('active')}))
								 );
						
						i++;
					}
						
					that.nSecondary = $('<div>', {'class':'bar bar-standard bar-header-secondary'})
						.append($('<button>', {'type':'button', 'class':'btn pull-left control-item', html: '&laquo;'})
							.click(function(){that.Prev()})
						)
						.append($('<button>', {'type':'button', 'class':'btn pull-right control-item', html: '&raquo;'})
							.click(function(){that.Next()})
						)
						.append($('<div>', {'class':'segmented-control'})
							.append($('<a>', {'class':'control-item', html: 'Info', 'href':'#info'}))
							.append($('<a>', {'class':'control-item', html: 'Playlist', 'href':'#playlist'})
								.on('click touch touchend', function(){
									$.ajax({
										url: server + '/requests/playlist.json',
										success: function(data)
										{
											that.plModal.empty();
											that.buildPlaylist(data);
										},
										dataType:'json'
									})
								})
							)
							.append($('<a>', {'class':'control-item', html: 'Streams', 'href':'#streams'}))
						 )

						.appendTo('body');
// 					that.nSecFooter = $('<div>', {'class':'bar bar-standard bar-footer-secondary'})
// 						.append($('<button>', {'class':'btn pull-left'}).append('<span class="icon icon-back"></span> Prev'))
// 						.append($('<button>', {'class':'btn pull-right'}).append('<span class="icon icon-next"></span> Next'))
// 						.append($('<button>', {'class':'btn', text:'Chapters'}))
// 						.appendTo('body');


// 					console.log(that.status.information.category.meta);
					that.actualImg = that.status.information.category.meta.filename;
				});

// 			this.albumArt.fadeIn(500, function () {
// 				$(this).removeAttr('height').removeAttr('width')
// 				console.log($(this).text());
// 			});
		}
		else
		{
			if(this.nSecondary)
				this.nSecondary.remove();
			this.albumArt.attr('src', 'img/vlc-48.png');
		}
			
		return this;
	}
	
}

$(document).ready(function(){
	new VLC().updateStatus();
// 	$('#settings').addClass('active');
});